<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2013 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: user_birthdate_include.php
| Author: Digitanium
| Modified: Pisatel
| http://www.meweb.ru
| Version 1.02
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

// Display user field input
if ($profile_method == "input") {
 if (isset($user_data['user_birthdate']) && $user_data['user_birthdate'] != "0000-00-00") {
  $user_birthdate = $user_data['user_birthdate'];
 } else {
  $user_birthdate = "0-0-0";
 }
 
 $user_birthdate = explode("-", $user_birthdate);
 $user_year = number_format($user_birthdate['0'], 0, ".", "");
 $user_month = number_format($user_birthdate['1'], 0, ".", "");
 $user_day = number_format($user_birthdate['2'], 0, ".", "");

 echo "<tr>\n";
 echo "<td class='tbl".$this->getErrorClass("user_birthdate")."'>";
 echo "<label for='user_day_input'>".$locale['uf_birthdate'].$required." <span class='small2'>".$locale['uf_dmy']."</span></label></td>\n";
 echo "<td class='tbl".$this->getErrorClass("user_birthdate")."'>";
 echo "<select id='user_day_input' name='user_day' class='textbox'>\n<option value=''>&nbsp;</option>\n";
 for ($bi = 1; $bi <= 31; $bi++) { echo "<option value='".$bi."'".($user_day == $bi ? " selected='selected'" : "").">".$bi."</option>\n"; }
 echo "</select>\n<select id='user_month_input' name='user_month' class='textbox'>\n<option value=''>&nbsp;</option>\n";
 for ($bi = 1; $bi <= 12; $bi++) { echo "<option value='".$bi."'".($user_month == $bi ? " selected='selected'" : "").">".$bi."</option>\n"; }
 echo "</select>\n<select id='user_year_input' name='user_year' class='textbox'>\n<option value=''>&nbsp;</option>\n";
 for ($bi = date("Y"); $bi > (date("Y") - 99); $bi--) { echo "<option value='".$bi."'".($user_year == $bi ? " selected='selected'" : "").">".$bi."</option>\n"; }
 echo "</select>\n</td>\n";
 echo "</tr>\n";

 if ($required) { 
  $this->setRequiredJavaScript("user_day", $locale['uf_birthdate_error']); 
  $this->setRequiredJavaScript("user_month", $locale['uf_birthdate_error']); 
  $this->setRequiredJavaScript("user_year", $locale['uf_birthdate_error']); 
 }

// Display in profile
} elseif ($profile_method == "display") {
 if ($user_data['user_birthdate'] != "0000-00-00") {
  echo "<tr>\n";
  echo "<td class='tbl1'>".$locale['uf_birthdate']."</td>\n";
  echo "<td align='right' class='tbl1'>";
  $months = explode("|", $locale['months_sm']);
  $user_birthdate = explode("-", $user_data['user_birthdate']);
  echo number_format($user_birthdate['2'])." ".$months[number_format($user_birthdate['1'])]." ".$user_birthdate['0'];
  echo "</td>\n</tr>\n";
  
  function getAge($y, $m, $d)
{
  if (($m > date('m')) || ($m == date('m') && $d > date('d'))){
  return(date('Y')-$y-1);
} else {
  return(date('Y')-$y);
    }
  }
 
  
  function getWord($number, $suffix) {
  $keys = array(2, 0, 1, 1, 1, 2);
  $modern = $number%100;
  $suffix_key = ($modern > 7 && $modern < 20) ?2:
  $keys[min($modern%10, 5)];
  return $suffix[$suffix_key];
   }
 
  $age_year = getAge($user_birthdate['0'], $user_birthdate['1'], $user_birthdate['2']);
  if (($age_year)>0){
  echo "<tr>\n";
  echo "<td class='tbl1'>".$locale['uf_birthdate_year']."</td>\n";
  echo "<td align='right' class='tbl1'>";

  if ($user_birthdate['1'] == date('m') && $user_birthdate['2'] == date('d')){
    echo "<span id='rainbowText'>".$locale['uf_happy_birthday']."</span>&nbsp;";
  echo "<script type='text/javascript'>
var speed=50;
if(document.all||document.getElementById){var storetext=document.getElementById?document.getElementById('rainbowText'):document.all.rainbowText;}
var hex=new Array('00','14','28','3C','50','64','78','8C','A0','B4','C8','DC','F0'),r=102,g=0,b=0,seq=1;
function changetext(){rainbow='#'+hex[r]+hex[g]+hex[b];storetext.style.color=rainbow;}
function change(){if(seq==6){b--;if(b==0)seq=1}if(seq==5){r++;if(r==12)seq=6}if(seq==4){g--;if(g==0)seq=5}if(seq==3){b++;if(b==12)seq=4}if(seq==2){r--;if(r==0)seq=3}if(seq==1){g++;if(g==12)seq=2}changetext()}
function starteffect(){if(document.all||document.getElementById){flash=setInterval('change()',speed)}}
starteffect();
</script>\n";

  echo "<img src='".INCLUDES."user_fields/images/birthdate.png' alt='".$locale['uf_happy_birthday']."'/>&nbsp;&nbsp;";
}

  echo $age_year."&nbsp;".getWord($age_year, $locale['arrsuf'])."</td>\n</tr>\n";
   }
}

// Insert and update
} elseif ($profile_method == "validate_insert" || $profile_method == "validate_update") {
 // Get input data
 $user_month = 0; $user_day = 0; $user_year = 0;
 if (isset($_POST['user_year']) && isnum($_POST['user_year']) && $_POST['user_year'] != 0) {
  $user_year = $_POST['user_year'];
 }
 if (isset($_POST['user_month']) && isnum($_POST['user_month']) && $_POST['user_month'] != 0) {
  $user_month = $_POST['user_month'];
 }
 if (isset($_POST['user_day'])&& isnum($_POST['user_day']) && $_POST['user_day'] != 0 ) {
  $user_day = $_POST['user_day'];
 }
 
 if (($user_month != 0 && $user_day != 0 && $user_year != 0)  || $this->_isNotRequired("user_birthdate")) {
  // Set update or insert user data
  $this->_setDBValue("user_birthdate", $user_year."-".$user_month."-".$user_day);
 } else {
  $this->_setError("user_birthdate", $locale['uf_birthdate_error'], true); 
 }
}
?>